#include <libtools.h>
#include <anymap.h>

typedef std::function<int(com::Anymap)> IntFunc;
typedef std::function<bool(com::Anymap)> BoolFunc;
typedef std::function<bool*(com::Anymap)> BoolArrFunc;  

IntFunc LoadEntry(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolFunc LoadPred(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolArrFunc LoadSelector(std::string lib, std::string func){
    DllHandle handler;
    return com::lib::loadFunction<bool* (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

void check_pred(bool predval, std::string predname) {
    if predval{
        std::cout<<"Predicate"<<predname<<"returned FALSE!"<<std::endl;
        exit(-1)
    }   
}

int main(int argc, char const *argv[])
{   
    auto data = com::Anymap();
    //Predicates
    auto test_funcs.simplest_positiveness_predicate = LoadPred("test_funcs.simplest", "positiveness_predicate"); 
    //Entry functions
    auto test_funcs.simplest_increment_a_edge = LoadEntry("test_funcs.simplest", "increment_a_edge"); 
    //Selectors
    //Branch tokens
    bool* SEL___BEGIN__ = new bool[1];
    std::fill_n(SEL___BEGIN__, 1, true);
    bool* SEL___END__ = new bool[0];
    std::fill_n(SEL___END__, 0, false);

if (SEL___BEGIN__[0]){
	check_pred(test_funcs.simplest_positiveness_predicate(data), "test_funcs.simplest_positiveness_predicate");
	test_funcs.simplest_increment_a_edge(data);
	check_pred(test_funcs.simplest_positiveness_predicate(data), "test_funcs.simplest_positiveness_predicate");
	test_funcs.simplest_increment_a_edge(data);
}
if (!(false || SEL___BEGIN__[0] )){
	for (int seli = 0; seli < 0; seli++)
		SEL___END__[seli]=false;
}else {
	for (int seli = 0; seli < 0; seli++)
		SEL___END__[seli]=true;
}


TERM:
    std::cout<<"Termination!\n"; 
    return 0;
}
